exec("rtb/client/scripts/sol_chatcol.cs");
//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Enter Chat Message Hud
//----------------------------------------------------------------------------

//------------------------------------------------------------------------------

function MessageHud::open(%this)
{
   %offset = 6;

   if(%this.isVisible())
      return;

   if(%this.isTeamMsg)
      %text = "TEAM:";
   else if(%this.isLocalMsg)
      %text = "LOCAL:";
   else
      %text = "GLOBAL:";

   MessageHud_Text.setValue(%text);
   
   %windowPos = "8 " @ ( getWord( outerChatHud.position, 1 ) + getWord( outerChatHud.extent, 1 ) + 1 );
   %windowExt = getWord( OuterChatHud.extent, 0 ) @ " " @ getWord( MessageHud_Frame.extent, 1 );
   
   %textExtent = getWord(MessageHud_Text.extent, 0);
   %ctrlExtent = getWord(MessageHud_Frame.extent, 0);

   Canvas.pushDialog(%this);
   
   messageHud_Frame.position = %windowPos;
   messageHud_Frame.extent = %windowExt;
   MessageHud_Edit.position = setWord(MessageHud_Edit.position, 0, %textExtent + %offset);
   MessageHud_Edit.extent = setWord(MessageHud_Edit.extent, 0, %ctrlExtent - %textExtent - (2 * %offset));
   
   %this.setVisible(true);
   deactivateKeyboard();
   MessageHud_Edit.makeFirstResponder(true);
   commandToServer('isTalking');
}

//------------------------------------------------------------------------------

function MessageHud::close(%this)
{
   if(!%this.isVisible())
      return;

   commandToServer('stopTalking');
      
   Canvas.popDialog(%this);
   %this.setVisible(false);
   if ( $enableDirectInput )
      activateKeyboard();
   MessageHud_Edit.setValue("");
}


//------------------------------------------------------------------------------

function MessageHud::toggleState(%this)
{
   if(%this.isVisible())
      %this.close();
   else
      %this.open();
}

//------------------------------------------------------------------------------

function MessageHud_Edit::onEscape(%this)
{
   MessageHud.close();
}

//------------------------------------------------------------------------------

function MessageHud_Edit::eval(%this)
{
   %text = trim(%this.getValue());
   if(%text !$= "")
   {
      if(MessageHud.isTeamMsg)
	{
	%text = strreplace(%text, "[red]", "\c3");
	%text = strreplace(%text, "[blue]", "\c5");
	%text = strreplace(%text, "[green]", "\c2");
	%text = strreplace(%text, "[yellow]", "\c1");
	%text = strreplace(%text, "[white]", "\c0");
	%text = strreplace(%text, "[grey]", "\c4");
	%text = strreplace(%text, "[tilde]", "~");
	%text = strreplace(%text, "[line]", "\n");
        if($Pref::MsgColour $= "false")
	{
        commandToServer('teammessageSent', %text);
	}
	else
	{
	commandToServer('teammessageSent', $Pref::ChatCol1 @ %text @ $Pref::ChatCol2);
	}
	}
      else if(MessageHud.isLocalMsg)
	{
	%text = strreplace(%text, "[red]", "\c3");
	%text = strreplace(%text, "[blue]", "\c5");
	%text = strreplace(%text, "[green]", "\c2");
	%text = strreplace(%text, "[yellow]", "\c1");
	%text = strreplace(%text, "[white]", "\c0");
	%text = strreplace(%text, "[grey]", "\c4");
	%text = strreplace(%text, "[tilde]", "~");
	%text = strreplace(%text, "[line]", "\n");
        if($Pref::MsgColour $= "false")
	{
        commandToServer('localmessageSent', %text);
	}
	else
	{
	commandToServer('localmessageSent', $Pref::ChatCol1 @ %text @ $Pref::ChatCol2);
	}
	}
      else
      {
	%text = strreplace(%text, "[red]", "\c3");
	%text = strreplace(%text, "[blue]", "\c5");
	%text = strreplace(%text, "[green]", "\c2");
	%text = strreplace(%text, "[yellow]", "\c1");
	%text = strreplace(%text, "[white]", "\c0");
	%text = strreplace(%text, "[grey]", "\c4");
	%text = strreplace(%text, "[tilde]", "~");
	%text = strreplace(%text, "[line]", "\n");
        if($Pref::MsgColour $= "false")
	{
        commandToServer('messageSent', %text);
	}
	else
	{
	commandToServer('messageSent', $Pref::ChatCol1 @ %text @ $Pref::ChatCol2);
	}
      }
   }

   MessageHud.close();
}

   
//----------------------------------------------------------------------------
// MessageHud key handlers

function toggleMessageHud(%make)
{
   if(%make)
   {
      MessageHud.isTeamMsg = false;
      MessageHud.isLocalMsg = false;
      MessageHud.toggleState();
   }
}

function teamMessageHud(%make)
{
   if(%make)
   {
      MessageHud.isTeamMsg = true;
      MessageHud.isLocalMsg = false;
      MessageHud.toggleState();
   }
}

function localMessageHud(%make)
{
   if(%make)
   {
      MessageHud.isTeamMsg = false;
      MessageHud.isLocalMsg = true;
      MessageHud.toggleState();
   }
}
